#include <thread>
#include <iostream>
#include <mutex>

using namespace std;

mutex m;
int compteur = 10;

void worker1()
{
	unique_lock<mutex> monlock(m);
	while(compteur > 0) 
	{	
		sleep(1);
		cout << "Worker 1 travaille" << endl;
		compteur--;
	}
}

void worker2()
{
	sleep(1);
	unique_lock<mutex> monlock(m);
	while(compteur > -5) 
	{
		sleep(1);	
		cout << "Worker 2  travaille" << endl;
		compteur--;
	}
}


int main(int argc, char const* argv[])
{	
	thread t1(worker1);
	thread t2(worker2);
	t1.join();
	t2.join(); 
	cout << "Programme terminé" << endl;
	return 0;
}
